SystemOrganization addCategory: #DevPacerPharo20!

!MCCacheRepository methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 15:40'!
storeVersion: aVersion
	self basicStoreVersion: (self prepareVersionForStorage: aVersion).
	self sendNotificationsForVersion: aVersion.! !

!TestRunner methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 15:47'!
updateResults
	"<lint: #expect rule: #guardingClause>"
	"<lint: #expect rule: #longMethods>"

	self updateStatus: false.
	
	"BEGIN PATCH DevPacer"
	result runCount > 0
		ifTrue: [
			(result hasErrors or: [result hasFailures])
				ifTrue: [TestPacer colorOfTestRunnerGotNotGreen]
				ifFalse: [TestPacer colorOfTestRunnerGotGreen].
			].
	"END PATCH DevPacer"
	
	failedList size = result failures size ifFalse: [
		failedList := result failures asArray
			sort: [ :a :b | a printString <= b printString ].
		failedSelected := nil.
		self 
			changed: #failedList; 
			changed: #failedSelected;
			changed: #hasFailures;
			changed: #hasProgress;
			changed: #hasFailuresOrErrors  ].
	errorList size = result errors size ifFalse: [
		errorList := result errors asArray
			sort: [ :a :b | a printString <= b printString ].
		errorSelected := nil.
		self 
			changed: #errorList; 
			changed: #errorSelected;
			changed: #hasErrors;
			changed: #hasProgress;
			changed: #hasFailuresOrErrors  ].! !

!MCRepository methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 15:42'!
storeVersion: aVersion
	self basicStoreVersion: (self prepareVersionForStorage: aVersion).
	ImageSavePacer systemChanged.
	self sendNotificationsForVersion: aVersion! !

!SmalltalkImage methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 17:08'!
saveAsNewVersionDotNumber
	|currName dotIndex|
	currName := self imageFile basenameWithoutExtension.
	dotIndex := currName reverseIndexOf: $..
	self saveAs:
		(dotIndex > 0
			ifTrue: [ (currName first: dotIndex-1), '.', ((currName allButFirst: dotIndex) asNumber + 1) printString ]
			ifFalse: [ currName, '.1' ]).! !

!SmalltalkImage methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 15:45'!
snapshot: save andQuit: quit
	"Mark the changes file and close all files as part of #processShutdownList.
	If save is true, save the current state of this Smalltalk in the image file.
	If quit is true, then exit to the outer OS shell.
	The latter part of this method runs when resuming a previously saved image. This resume logic checks for a document file to process when starting up."

	| snapshotResult isNewImage startupErrors |
	"BEGIN PATCH DevPacer"
	save ifTrue: [ImageSavePacer systemSaved].
	"END PATCH DevPacer"
	self addSnapshotRecord: save andQuit: quit.
	self shutDownImage: quit.
									
	save
		ifTrue: [ 
			snapshotResult := self snapshotPrimitive.	"<-- PC frozen here on image file"
			isNewImage := snapshotResult == true ]
		ifFalse: [ isNewImage := false ].
	(quit and: [ isNewImage not ])
		ifTrue: [ self quitPrimitive ].
	
	"create a new session object if we're booting"
	isNewImage ifTrue: [ session := self newSessionObject ].
	
	self startupImage: isNewImage snapshotWorked: snapshotResult.
	
	"We return the resuming state, which may be useful for users to know the state of the image"
	^ isNewImage! !

!CommitPacer classSide methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 15:33'!
registerToAnnouncements

	| sel |
	sel := #systemChanged:.
	SystemAnnouncer uniqueInstance weak
		on: CategoryAdded send: sel to: self;
		on: CategoryRemoved send: sel to: self;
		on: CategoryRenamed send: sel to: self;
		on: ClassAdded send: sel to: self;
		on: ClassCommented send: sel to: self;
		on: ClassModifiedClassDefinition send: sel to: self;
		on: ClassRecategorized send: sel to: self;
		on: ClassRemoved send: sel to: self;
		on: ClassRenamed send: sel to: self;
		on: ClassReorganized send: sel to: self;
		on: MethodAdded send: sel to: self;
		on: MethodModified send: sel to: self;
		on: MethodRecategorized send: sel to: self;
		on: MethodRemoved send: sel to: self;
		on: ProtocolAdded send: sel to: self;
		on: ProtocolRemoved send: sel to: self! !

!CommitPacer classSide methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 15:33'!
unregisterToAnnouncements
SystemAnnouncer uniqueInstance unsubscribe: self.! !

!ImageSavePacer classSide methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 15:39'!
initialize

	self registerToAnnouncements.! !

!ImageSavePacer classSide methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 16:48'!
registerToAnnouncements

	SystemAnnouncer uniqueInstance weak
		on: CategoryAdded send: #systemChanged to: self;
		on: CategoryRemoved send: #systemChanged to: self;
		on: CategoryRenamed send: #systemChanged to: self;
		on: ClassAdded send: #systemChanged to: self;
		on: ClassCommented send: #systemChanged to: self;
		on: ClassModifiedClassDefinition send: #systemChanged to: self;
		on: ClassRecategorized send: #systemChanged to: self;
		on: ClassRemoved send: #systemChanged to: self;
		on: ClassRenamed send: #systemChanged to: self;
		on: ClassReorganized send: #systemChanged to: self;
		on: MethodAdded send: #systemChanged to: self;
		on: MethodModified send: #systemChanged to: self;
		on: MethodRecategorized send: #systemChanged to: self;
		on: MethodRemoved send: #systemChanged to: self;
		on: ProtocolAdded send: #systemChanged to: self;
		on: ProtocolRemoved send: #systemChanged to: self;
		on: ExpressionEvaluated send: #systemChanged to: self
! !

!ImageSavePacer classSide methodsFor: '*DevPacerPharo20' stamp: 'HwaJong 3/16/2013 16:29'!
unregisterToAnnouncements
SystemAnnouncer uniqueInstance unsubscribe: self.! !
ImageSavePacer initialize!
